//George Koutsogiannakis
//LAB 2
package folder1.folder2;
import java.text.DecimalFormat;

public class Vehicle 
{
	private String owners_name;
	private double acceleration;
	private int time;
	private VehicleEngine ve;
	private static int vehicleID;
	private int currentID;
	private double velocity;
	private double distance;
	VehicleType vt;
	
	public Vehicle()
	{
		owners_name=" ";

		acceleration=0.0;
		time=0;
		velocity=0.0;
		distance=0.0;
		ve=null;
		vt=null;
		vehicleID++;
		currentID=vehicleID;
		
	}

	public Vehicle(double a, int t, String on, VehicleEngine eng)
	{
		vehicleID++;
		currentID=vehicleID;
		
		acceleration=a;
		time=t;
		owners_name=on;
		ve=eng;
		vt=null;
		velocity=0.0;
		distance=0.0;
	}
    public VehicleType getVehicleType()
	{
		return vt;
	}

	public double getVelocity()
	{
		return velocity;
	}

	public double getDistance()
	{
		return distance;
	}

	public String getOwnersName()
	{
		return owners_name;
	}

	public double getAcceleration()
	{

		return acceleration;
	}


	public int getTime()
	{
		return time;
	}

	public int getVehicleID()
	{
		return vehicleID;
	}

	public int getCurrentID()
	{

		return currentID;
	}

	public VehicleEngine getVehicleEngine()
	{
		return ve;
	}
	
	public void setVehicleType(VehicleType vehty)
	{
		vt=vehty;
	}

	
	public void setOwnersName(String name)
	{
		owners_name=name;
	}

	public void setTime(int t)
	{
		time=t;
	}

	public void setAcceleration(double ac)
	{

		acceleration=ac;

	}

	public void setVehicleEngine(VehicleEngine e)
	{
		ve=e;
	}

	public String toString()
	{

		String str="The vehicle ID is:"+" "+currentID+" "+"The name of the owner is:"+" "+owners_name+" "+"The acceleration is:"+" "+acceleration+
		"m/sec/sec"+" "+"The engine type is:"+" "+ve+"And the traveling time is;"+time+" "+"seconds"+" "+"The Vehicle Type is"+" "+vt+" "+"The velocity is"+" "+velocity+
		"m/sec"+" "+"The distance traveled is"+" "+distance+"meters";
		return str;
	}

	public void calculateV(double i)
	{
		DecimalFormat df=new DecimalFormat("#.##");
		double unformattedvelocity=acceleration*time+i;
		String strv=df.format(unformattedvelocity);
		velocity=Double.parseDouble(strv);

		
	}

	public void calculateD(double i, double d)
	{
		DecimalFormat df=new DecimalFormat("#.##");
		double timed=(double)time;
		double t=Math.pow(timed, 2.0);
		double unformatteddistance=0.5*acceleration*t+i*time+d;
		String strd=df.format(unformatteddistance);
		distance=Double.parseDouble(strd);
		
	}

	public boolean equals(Vehicle v)
	{
		if((this.getVehicleType().equals(v.getVehicleType()))&&(this.getVehicleEngine().equals(v.getVehicleEngine())))
		   return true;
		else
		    return false;
	}

	
}
